/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* vim:set ts=2 sw=2 sts=2 et cindent tw=79 ft=idl: */
/*
 * Copyright (C) 2007,2008 Sergey Yanovich <ynvich@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include "aaIDataNode.idl"

/*
 * The aaITransaction interface
 * @status UNSTABLE
 */

interface aaIFact;
interface aaIBalance;

[scriptable, uuid(d8416cc3-f3b3-4c13-8b4a-ad0c18e5db67)]
interface aaITransaction : aaIDataNode
{
  attribute aaIFact fact;
  [noscript, notxpcom] aaIFact pickFact();

  attribute double value;
  [noscript, notxpcom] double pickValue();

  readonly attribute boolean hasEarnings;
  [noscript, notxpcom] boolean pickHasEarnings();

  attribute double earnings;
  [noscript, notxpcom] double pickEarnings();

  void initBalanceFrom(in aaIBalance aBalanceFrom);
  void initBalanceTo(in aaIBalance aBalanceTo);
  void initIncome(in aaIBalance aIncome);
  readonly attribute aaIBalance balanceFrom;
  readonly attribute aaIBalance balanceTo;
  readonly attribute aaIBalance income;
};
